//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// Z poniższym kodem nie jest związana żadna gwarancja poprawności działania.
// Program został dołączony do książki ".NET CLR. Księga eksperta" w celu
// ilustracji koncepcji i zasad przedstawionych w tej książce. Program może być 
// używany na własne ryzyko.
//
// Przyznaje się prawo do użycia lub kopiowania tego oprogramowania do dowolnego celu
// bez konieczności ponoszenia żadnych opłat pod warunkiem, że powyższe uwagi zostaną 
// zachowane we wszystkich kopiach. Przyznaje się także prawo do modyfikacji kodu
// i dystrybucji zmodyfikowanego kodu pod warunkiem zachowania powyższych uwag
// oraz dołączenia informacji mówiącej o modyfikacji kodu.
//
//  
using System;
using System.Collections;

namespace FrameworkLibraries
{
	public class ICollectionMain 
	{
		static void Main(string [] args)
		{
			ArrayList al = new ArrayList();
			al.Add("To");
			al.Add("jest");
			al.Add("test");
			al.Add(0);
			al.Add(1);
			ICollection ic = (ICollection)al;
			lock(ic.SyncRoot)
			{
				Console.WriteLine("Zsynchronizowany: {0}", ic.IsSynchronized);
				Console.WriteLine("Licznik: {0}", ic.Count);
				Object [] oa = new Object [6];
				ic.CopyTo(oa, 0);
				foreach(object o in oa)
				{
					Console.WriteLine("{0} {1}", o, o.GetType());
				}
			}
		}
	}
}